<!-- HTML header for doxygen 1.8.18-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=9" />
    <meta name="generator" content="Doxygen 1.9.1" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>VizBlocks: Potentiometer Class Reference</title>
    <link href="tabs.css" rel="stylesheet" type="text/css" />
    <script type="text/javascript" src="jquery.js"></script>
    <script type="text/javascript" src="dynsections.js"></script>
     <link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
    <link href="my_customdoxygen.css" rel="stylesheet" type="text/css" />
  </head>
  <body>
    <div id="top">
      <!-- do not remove this div, it is closed by doxygen! -->
      <header id="header" class="desktop">
        <div>
          <div class="inner-header">
            <div class="logotype">
              <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" aria-hidden="true" title="Site home"
                >VizBlocks</a
              >
            </div>
            <div class="navigation">
              <button
                onclick="toggleBurger()"
                type="button"
                aria-label="toggle burger menu"
              >
                <i class="fa fa-bars"></i>
              </button>
              <nav id="menu" class="collapse">
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" class="home">Home</a>
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/about" class="about">About</a>
                <a
                  href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials/0_getting_started.html"
                  class="start"
                  >Get Started</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials" class="tutorials"
                  >Tutorials</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/docs/html" class="docs"
                  >Technical Info</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/contact" class="content">Contact</a>
              </nav>
            </div>
          </div>
        </div>
        <script>
          const toggleBurger = () => {
            const menu = document.getElementById("menu");
            if (menu.className === "collapse") {
              menu.className = "extend";
            } else {
              menu.className = "collapse";
            }
          };
          const touchDevice = "ontouchstart" in document.documentElement;
          if (touchDevice) {
            const header = document.getElementById("header");
            header.className = "mobile";
          }
        </script>
      </header>
      <!-- end header part -->
    </div>
  </body>
</html>
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a> &#124;
<a href="class_potentiometer-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Potentiometer Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Psuedo-event-driven potentiometer class. Events are split into stable and unstable updates to prevent flooding the mqtt channel with many messages while the slider is being set, while allowing for a local display element (i.e. an led) to give real-time feedback.  
 <a href="class_potentiometer.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_potentiometer_8h_source.html">Potentiometer.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a6a9caf03bab70816829c574ee7e88a6b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_potentiometer.html#a6a9caf03bab70816829c574ee7e88a6b">check</a> ()</td></tr>
<tr class="memdesc:a6a9caf03bab70816829c574ee7e88a6b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Polls the potentiometer's value and detects events. This should be called in the sketch's loop() function.  <a href="class_potentiometer.html#a6a9caf03bab70816829c574ee7e88a6b">More...</a><br /></td></tr>
<tr class="separator:a6a9caf03bab70816829c574ee7e88a6b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a70a53b8e012420e689a38d1751b4269e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_potentiometer.html#a70a53b8e012420e689a38d1751b4269e">getId</a> ()</td></tr>
<tr class="memdesc:a70a53b8e012420e689a38d1751b4269e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the potentiometer ID.  <a href="class_potentiometer.html#a70a53b8e012420e689a38d1751b4269e">More...</a><br /></td></tr>
<tr class="separator:a70a53b8e012420e689a38d1751b4269e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0ee40840fe135d6f1799fecdbb4d9f70"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_potentiometer.html#a0ee40840fe135d6f1799fecdbb4d9f70">getValue</a> ()</td></tr>
<tr class="memdesc:a0ee40840fe135d6f1799fecdbb4d9f70"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the current stable potentiometer value.  <a href="class_potentiometer.html#a0ee40840fe135d6f1799fecdbb4d9f70">More...</a><br /></td></tr>
<tr class="separator:a0ee40840fe135d6f1799fecdbb4d9f70"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af2f25ccdc72808fc5e4baeeb60fe9410"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_potentiometer.html#af2f25ccdc72808fc5e4baeeb60fe9410">Potentiometer</a> (int pin, int id=99)</td></tr>
<tr class="memdesc:af2f25ccdc72808fc5e4baeeb60fe9410"><td class="mdescLeft">&#160;</td><td class="mdescRight">Class constructor.  <a href="class_potentiometer.html#af2f25ccdc72808fc5e4baeeb60fe9410">More...</a><br /></td></tr>
<tr class="separator:af2f25ccdc72808fc5e4baeeb60fe9410"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a17b7977261eebcac2d6d5dbcd7adf167"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_potentiometer.html#a17b7977261eebcac2d6d5dbcd7adf167">setEventHandler</a> (void(*function)(<a class="el" href="class_potentiometer.html">Potentiometer</a> *, uint8_t, uint8_t))</td></tr>
<tr class="memdesc:a17b7977261eebcac2d6d5dbcd7adf167"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the function that is called any time a button event is detected. Some example callback functions can be found in the InputNode example.  <a href="class_potentiometer.html#a17b7977261eebcac2d6d5dbcd7adf167">More...</a><br /></td></tr>
<tr class="separator:a17b7977261eebcac2d6d5dbcd7adf167"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr class="memitem:a4898ad98a6a277551036a8b9558533df"><td class="memItemLeft" align="right" valign="top">static const uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_potentiometer.html#a4898ad98a6a277551036a8b9558533df">kEventStableUpdate</a> = 0</td></tr>
<tr class="memdesc:a4898ad98a6a277551036a8b9558533df"><td class="mdescLeft">&#160;</td><td class="mdescRight">Event ID for a stable update (potentiometer has been changed, then been stable longer than <code>_interval</code>).  <a href="class_potentiometer.html#a4898ad98a6a277551036a8b9558533df">More...</a><br /></td></tr>
<tr class="separator:a4898ad98a6a277551036a8b9558533df"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a06d7c4ac6942d9fad402d136f2bfa6ed"><td class="memItemLeft" align="right" valign="top">static const uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_potentiometer.html#a06d7c4ac6942d9fad402d136f2bfa6ed">kEventUnstableUpdate</a> = 1</td></tr>
<tr class="memdesc:a06d7c4ac6942d9fad402d136f2bfa6ed"><td class="mdescLeft">&#160;</td><td class="mdescRight">Event ID for a stable update (potentiometer has been changed, but not stopped moving yet).  <a href="class_potentiometer.html#a06d7c4ac6942d9fad402d136f2bfa6ed">More...</a><br /></td></tr>
<tr class="separator:a06d7c4ac6942d9fad402d136f2bfa6ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Psuedo-event-driven potentiometer class. Events are split into stable and unstable updates to prevent flooding the mqtt channel with many messages while the slider is being set, while allowing for a local display element (i.e. an led) to give real-time feedback. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="af2f25ccdc72808fc5e4baeeb60fe9410"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af2f25ccdc72808fc5e4baeeb60fe9410">&#9670;&nbsp;</a></span>Potentiometer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Potentiometer::Potentiometer </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>pin</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>id</em> = <code>99</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Class constructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a6a9caf03bab70816829c574ee7e88a6b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6a9caf03bab70816829c574ee7e88a6b">&#9670;&nbsp;</a></span>check()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Potentiometer::check </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Polls the potentiometer's value and detects events. This should be called in the sketch's loop() function. </p>

</div>
</div>
<a id="a70a53b8e012420e689a38d1751b4269e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a70a53b8e012420e689a38d1751b4269e">&#9670;&nbsp;</a></span>getId()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Potentiometer::getId </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns the potentiometer ID. </p>

</div>
</div>
<a id="a0ee40840fe135d6f1799fecdbb4d9f70"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0ee40840fe135d6f1799fecdbb4d9f70">&#9670;&nbsp;</a></span>getValue()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Potentiometer::getValue </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns the current stable potentiometer value. </p>

</div>
</div>
<a id="a17b7977261eebcac2d6d5dbcd7adf167"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a17b7977261eebcac2d6d5dbcd7adf167">&#9670;&nbsp;</a></span>setEventHandler()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Potentiometer::setEventHandler </td>
          <td>(</td>
          <td class="paramtype">void(*)(<a class="el" href="class_potentiometer.html">Potentiometer</a> *, uint8_t, uint8_t)&#160;</td>
          <td class="paramname"><em>function</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the function that is called any time a button event is detected. Some example callback functions can be found in the InputNode example. </p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a4898ad98a6a277551036a8b9558533df"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4898ad98a6a277551036a8b9558533df">&#9670;&nbsp;</a></span>kEventStableUpdate</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const uint8_t Potentiometer::kEventStableUpdate = 0</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Event ID for a stable update (potentiometer has been changed, then been stable longer than <code>_interval</code>). </p>

</div>
</div>
<a id="a06d7c4ac6942d9fad402d136f2bfa6ed"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a06d7c4ac6942d9fad402d136f2bfa6ed">&#9670;&nbsp;</a></span>kEventUnstableUpdate</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const uint8_t Potentiometer::kEventUnstableUpdate = 1</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Event ID for a stable update (potentiometer has been changed, but not stopped moving yet). </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>src/<a class="el" href="_potentiometer_8h_source.html">Potentiometer.h</a></li>
</ul>
</div><!-- contents -->
<!-- HTML footer for doxygen 1.8.18-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.9.1
</small></address>
</body>
</html>
